/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-angular-core";
import { Style } from "igniteui-angular-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var ScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeries, _super);
    function ScatterPolygonSeries() {
        var _this = _super.call(this) || this;
        _this.aav = null;
        _this.aas = new ScalerParams(1, ScatterPolygonSeries.ab1, ScatterPolygonSeries.ab1, false);
        _this.aat = new ScalerParams(1, ScatterPolygonSeries.ab1, ScatterPolygonSeries.ab1, false);
        _this.abh = null;
        _this.aan = 1;
        _this.aaj = 1;
        _this.ab = ScatterPolygonSeries.$;
        return _this;
    }
    ScatterPolygonSeries.prototype.bk = function () {
        return new ScatterPolygonSeries();
    };
    ScatterPolygonSeries.prototype.get_fr = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.get_fm = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.yp = function () {
        return this.aax();
    };
    ScatterPolygonSeries.prototype.zx = function (a) {
        var _this = this;
        var b = a;
        b.db(this.ab3);
        b.dc(this.aaw);
        _super.prototype.zx.call(this, a);
        if (this.d7(a)) {
            return;
        }
        var c, d;
        var e = a.getViewInfo(c, d);
        c = e.p0;
        d = e.p1;
        var f = this.getEffectiveViewport1(a);
        this.aas = new ScalerParams(1, d, c, this.xo.df);
        this.aas.c = f;
        this.aat = new ScalerParams(1, d, c, this.xq.df);
        this.aat.c = f;
        if (c.width < 1 || c.height < 1) {
            return;
        }
        this.aav = ((function () {
            var $ret = new ShapeAxisInfoCache();
            $ret.a = _this.xo;
            $ret.b = _this.xq;
            $ret.e = _this.xo.df;
            $ret.f = _this.xq.df;
            $ret.d = _this.dp;
            $ret.c = _this.x6;
            return $ret;
        })());
        if (this.aax()) {
            var g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
            b.du.l(g, 400, d, c, this.ie);
            b.du.j(g, false);
            if (this.yn()) {
                this.abe(a);
            }
        }
    };
    ScatterPolygonSeries.prototype.abe = function (a) {
        var _this = this;
        a.dy = true;
        this.xv.ay(this, this.yn(), runOn(this, this.xe));
        var b = this.xv.d;
        var c = b != null;
        var d = this.getEffectiveViewport1(a);
        var e = this.dp == null ? 0 : this.dp.count;
        a.d9(function (f) {
            if (f._visibility == 0) {
                var g = f.ak;
                var h = f.content;
                if (h == null) {
                    h = new DataContext();
                    f.content = h;
                }
                if (c) {
                    _this.zs(g, e, a.t);
                }
                _this.xv.ac(f, h);
            }
        });
    };
    ScatterPolygonSeries.prototype.aax = function () {
        return this.abh != null && ((this.aar != 1 && this.aar != 0) || this.abi != null);
    };
    ScatterPolygonSeries.prototype.ct = function () {
        return new ScatterPolygonSeriesView(this);
    };
    ScatterPolygonSeries.prototype.q7 = function (a) {
        _super.prototype.q7.call(this, a);
        this.aau = a;
    };
    ScatterPolygonSeries.prototype.get_hasMarkers = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.get_en = function () {
        return this.aar != 13 && this.aar != 1;
    };
    ScatterPolygonSeries.prototype.vv = function () {
        return this.abx;
    };
    ScatterPolygonSeries.prototype.vw = function () {
        return this.aby;
    };
    ScatterPolygonSeries.prototype.s7 = function () {
        return this.abg;
    };
    ScatterPolygonSeries.prototype.mf = function () {
        return this.mg(this, this.abh);
    };
    ScatterPolygonSeries.prototype.ip = function () {
        return this.aaz;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "aao", {
        get: function () {
            return this.aan;
        },
        set: function (a) {
            this.aan = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.aaq = function () {
        if (this.aap == 0) {
            return 1;
        }
        return this.aap;
    };
    ScatterPolygonSeries.prototype.st = function (a) {
        _super.prototype.st.call(this, a);
        this.aap = a;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "aak", {
        get: function () {
            return this.aaj;
        },
        set: function (a) {
            this.aaj = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.aam = function () {
        if (this.aal == 0) {
            return 2;
        }
        return this.aal;
    };
    ScatterPolygonSeries.prototype.ss = function (a) {
        _super.prototype.ss.call(this, a);
        this.aal = a;
    };
    ScatterPolygonSeries.prototype.su = function (a) {
        _super.prototype.su.call(this, a);
        this.aaz = a;
    };
    ScatterPolygonSeries.prototype.sp = function () {
        _super.prototype.sp.call(this);
        if (this.index < 0) {
            return;
        }
        if (this.abi != null) {
            this.aau.d8();
            this.aau.d5();
        }
        else {
            var a = MarkerSeries.xl(this, this.aar);
            var b = MarkerSeries.xy(a);
            if (b == null) {
                this.abg = MarkerSeries.yd;
            }
            else {
                this.aau.d2(b);
            }
        }
        if (this.abz != null && this.aar != 13) {
            this.sg("ActualMarkerBrush");
            var c = this.abx;
            this.aau.d6();
            this.aau.d3();
            var d = this.abx;
            var e = this.fi("ActualMarkerBrush", this.hw.f > 0 ? this.hw.d() : null, c, d);
            this.si("ActualMarkerBrush", e);
        }
        else {
            if (this.aar == 13) {
                this.abx = this.cw.b5();
            }
            else {
                if (this.aak != 2) {
                    if (this.dc != null) {
                        var f = this.dc.ww(this.index);
                        if (!isNaN_(this.id) && this.id != 1) {
                            f = BrushUtil.s(f, this.id);
                        }
                        this.abx = f;
                    }
                    else {
                        this.abx = null;
                    }
                }
            }
        }
        if (this.ab0 != null) {
            this.aau.d7();
            this.aau.d4();
        }
        else {
            if (this.aar == 13) {
                this.aby = this.cw.b5();
            }
            else {
                if (this.aap == 2) {
                    this.aby = this.abx;
                }
                else {
                    this.aby = this.dc == null ? null : this.dc.wx(this.index);
                }
            }
        }
        if (this.aak == 2 && this.abz == null && this.aar != 13) {
            if (this.aby != null) {
                var g = this.aby;
                if (!isNaN_(this.id) && this.id != 1) {
                    g = BrushUtil.s(g, this.id);
                }
                this.abx = g;
            }
            else {
                this.abx = null;
            }
        }
    };
    ScatterPolygonSeries.prototype.qy = function () {
        _super.prototype.qy.call(this);
        this.aao = this.aaq();
        this.aak = this.aam();
    };
    ScatterPolygonSeries.prototype.rg = function (a, b, c, d) {
        _super.prototype.rg.call(this, a, b, c, d);
        switch (b) {
            case ScatterPolygonSeries.$$p[3]:
            case ScatterPolygonSeries.$$p[11]:
            case ScatterPolygonSeries.$$p[7]:
            case ScatterPolygonSeries.$$p[9]:
            case ScatterPolygonSeries.$$p[10]:
                this.rm(b);
                this.q9();
                break;
            case ScatterPolygonSeries.$$p[6]:
                this.aao = this.aaq();
                this.rm(null);
                this.q9();
                break;
            case ScatterPolygonSeries.$$p[5]:
                this.aak = this.aam();
                this.rm(null);
                this.q9();
                break;
            case ScatterPolygonSeries.$$p[2]:
                this.abh = d;
                if (c == MarkerSeries.yd || d == MarkerSeries.yd || (c == null || d != null)) {
                    this.aau.ea();
                    this.ry(false);
                }
                this.cw.bx();
                if (this.toolTip != null && this.fj) {
                    this.ba.a$as(this, this.toolTip);
                }
                this.ry(false);
                this.qr();
                break;
            case ScatterPolygonSeries.$$p[12]:
                this.aau.db(this.ab3);
                this.ry(false);
                this.qr();
                break;
            case ScatterPolygonSeries.$$p[13]:
                this.aau.dc(this.aaw);
                this.ry(false);
                this.qr();
                break;
            case ScatterPolygonSeries.$$p[4]:
                this.ry(false);
                this.qr();
                break;
            case ScatterPolygonSeries.$$p[0]:
            case ScatterPolygonSeries.$$p[1]:
                if (this.aax()) {
                    this.ry(false);
                }
                break;
        }
    };
    ScatterPolygonSeries.prototype.a2 = function (a, b) {
        var c = this.aau.ch(a);
        var d = null;
        if (c != null) {
            d = c.content;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.a2.call(this, a, b);
    };
    ScatterPolygonSeries.prototype.abf = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    ScatterPolygonSeries.prototype.ed = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.xo;
        var g = new ScalerParams(1, this.dc.xm, this.w2, f.df);
        g.c = this.getEffectiveViewport1(this.cw);
        var h = this.xq;
        var i = new ScalerParams(1, this.dc.xm, this.w2, h.df);
        i.c = this.getEffectiveViewport1(this.cw);
        a.clear();
        this.aau.d9(function (j) {
            if (j._visibility == 0) {
                var k = new SeriesPointOfInterest();
                var l = j.n;
                var m = j.o;
                if (!e && (l < _this.w2.left || l > _this.w2.right || m < _this.w2.top || m > _this.w2.bottom)) {
                    return;
                }
                k.d = f.fw(l, g);
                k.e = h.fw(m, i);
                k.b = j.content;
                k.g = _this.vq;
                k.c = j.ak;
                if (_this.ha) {
                    k.g = _this.vx(j.ak);
                }
                a.add(k);
            }
        });
        return true;
    };
    ScatterPolygonSeries.prototype.aah = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.aav.d.count) {
            c = new Array(this.aav.d.count);
            for (var f = 0; f < this.aav.d.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.xo.df);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var h = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.xq.df);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = this.wt(a);
        var j = this.aav.a.fw(i.left, g);
        var k = this.aav.a.fw(i.right, g);
        var l = this.aav.b.fw(i.bottom, h);
        var m = this.aav.b.fw(i.top, h);
        if (this.aav.e) {
            var n = j;
            j = k;
            k = n;
        }
        if (this.aav.f) {
            var o = l;
            l = m;
            m = o;
        }
        var p = this.aav;
        var q = p.a;
        var r = p.b;
        var s;
        var t;
        var u = g.d.left;
        var v = g.d.right;
        var w = h.d.top;
        var x = h.d.bottom;
        for (var y = 0; y < this.aav.d.count; y++) {
            s = 0;
            t = 0;
            var z = null;
            var aa = a.cp.tryGetValue(y, z);
            z = aa.p1;
            if (z == null) {
                c[y].x = NaN;
                c[y].y = NaN;
            }
            else {
                var ab = z.c;
                var ac = RectUtil.l(ab);
                s = ac.x;
                t = ac.y;
                if (s >= u && s <= v && t >= w && t <= x) {
                    c[y].x = s;
                    c[y].y = t;
                }
                else {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterPolygonSeries.prototype.aay = function (a, b) {
        var e_3, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.dp;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
                c++;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    ScatterPolygonSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.qa(a, c, b);
        return c.toArray();
    };
    ScatterPolygonSeries.prototype.qa = function (a, b, c) {
        this.zp(a, b, c);
    };
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.ab1 = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:abx:abj', [Brush.$], 'ActualMarkerOutline:aby:abk', [Brush.$], 'ActualMarkerTemplate:abg:abl', [DataTemplate.$, null], 'MarkerBrush:abz:abm', [Brush.$], 'MarkerCollisionAvoidance:aai:abn', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:aal:abo', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:aap:abp', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:ab0:abq', [Brush.$], 'MarkerStyle:ab2:abr', [Style.$], 'MarkerTemplate:abi:abs', [DataTemplate.$, null], 'MarkerThickness:aaz:abt', [1, DeviceUtils.g(2)], 'MarkerType:aar:abu', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:ab3:abv', [Style.$, null], 'ShapeStyleSelector:aaw:abw', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
}(ShapeSeriesBase));
export { ScatterPolygonSeries };
/**
 * @hidden
 */
var ScatterPolygonSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeriesView, _super);
    function ScatterPolygonSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dy = false;
        _this.dp = null;
        _this.d0 = null;
        _this.dv = null;
        _this.dt = null;
        _this.dx = false;
        _this.dw = null;
        _this.d1 = null;
        _this.dq = new Marker();
        _this.eh = null;
        _this.dq = new Marker();
        _this.dq.content = new DataContext();
        _this.dv = a;
        _this.dw = new HashPool$2(Base.$, Marker.$);
        _this.d1 = new List$1(Marker.$, 0);
        _this.eb(_this.dw);
        _this.dt = new NumericMarkerManager(1, function (b) { return _this.dw.item(b); }, function (b) { return _this.dv.aav.d.item(b); }, runOn(_this, _this.ef), runOn(_this, _this.dn), runOn(_this, _this.dz), function () { return _this.dv.aai; });
        _this.dt.q = runOn(_this, _this.ei);
        return _this;
    }
    ScatterPolygonSeriesView.prototype.a4 = function () {
        _super.prototype.a4.call(this);
        if (!this.t) {
            this.dv.ab0 = Defaults.bb;
            this.dv.jt = Defaults.am;
            this.dv.aaz = Defaults.al;
            this.dv.aar = Defaults.f;
            this.dv.aal = Defaults.b;
        }
    };
    Object.defineProperty(ScatterPolygonSeriesView.prototype, "du", {
        get: function () {
            return this.dt;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeriesView.prototype.ef = function (a) {
        this.dv.abf(a, this.dw);
    };
    ScatterPolygonSeriesView.prototype.dn = function () {
        this.dp = this.dv.aah(this, this.dw, this.dp, this.ca, this.b9);
        return this.dp;
    };
    ScatterPolygonSeriesView.prototype.dz = function () {
        this.d0 = this.dv.aay(this.dw, this.d0);
        return this.d0;
    };
    ScatterPolygonSeriesView.prototype.di = function (a, b) {
        return this.dj(a, b, true);
    };
    ScatterPolygonSeriesView.prototype.cz = function (a, b, c) {
        _super.prototype.cz.call(this, a, b, c);
        ShapeSeriesViewBase.cy(this, a, b);
    };
    ScatterPolygonSeriesView.prototype.cx = function (a, b) {
        var c = a;
        if (c == null) {
            return;
        }
        c.an = b;
    };
    ScatterPolygonSeriesView.prototype.d9 = function (a) {
        this.dw.f(a);
    };
    ScatterPolygonSeriesView.prototype.eb = function (a) {
        a.create = runOn(this, this.ds);
        a.destroy = runOn(this, this.ed);
        a.activate = runOn(this, this.ec);
        a.disactivate = runOn(this, this.ee);
    };
    ScatterPolygonSeriesView.prototype.ds = function () {
        var _this = this;
        var a = new Marker();
        if (!this.dx) {
            a.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.f;
                return $ret;
            })());
        }
        a.ah = this.f.abg;
        this.d1.add(a);
        return a;
    };
    ScatterPolygonSeriesView.prototype.ch = function (a) {
        var b = this.dr(a, 0);
        if (b == null) {
            b = this.dr(a, 3);
        }
        return b;
    };
    ScatterPolygonSeriesView.prototype.dr = function (a, b) {
        var c;
        var d;
        var e;
        var f;
        for (var g = this.d1.count - 1; g >= 0; g--) {
            var h = this.d1._inner[g];
            if (h._visibility == 1 || h._opacity == 0) {
                continue;
            }
            c = (h.m / 2) + b;
            d = (h.l / 2) + b;
            e = h.ai;
            f = h.aj;
            if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                return h;
            }
        }
        return null;
    };
    ScatterPolygonSeriesView.prototype.ed = function (a) {
        a.content = null;
        this.d1.remove(a);
    };
    ScatterPolygonSeriesView.prototype.ec = function (a) {
        a._visibility = 0;
    };
    ScatterPolygonSeriesView.prototype.ee = function (a) {
        if (a.content != null) {
            (typeCast(DataContext.$, a.content)).item = null;
        }
        a._visibility = 1;
    };
    ScatterPolygonSeriesView.prototype.eg = function (a) {
        this.dx = a;
    };
    ScatterPolygonSeriesView.prototype.bv = function (a, b) {
        _super.prototype.bv.call(this, a, b);
        if (!this.dy) {
            var c = a;
            var d = c.content;
            if (d != null) {
                if (this.dv.abx != null) {
                    d.actualItemBrush = this.dv.abx;
                }
                else {
                    d.actualItemBrush = this.cj.vj;
                }
                if (this.dv.abx != null) {
                    d.outline = this.dv.aby;
                }
                else {
                    d.outline = this.cj.vn;
                }
                d.thickness = this.dv.aaz;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.bw = function (a, b) {
        _super.prototype.bw.call(this, a, b);
        var c = a;
        this.dq._visibility = c._visibility;
        this.dq.ah = c.ah;
        this.dq.width = c.width;
        this.dq.height = c.height;
        this.dq.m = c.m;
        this.dq.l = c.l;
        this.dq.n = c.n;
        this.dq.o = c.o;
        var d = this.b4(b);
        var e = this.dq.content;
        var f = c.content;
        e.item = f.item;
        e.series = f.series;
        e.thickness = f.thickness;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = this.dv.aaz + 3;
        }
    };
    ScatterPolygonSeriesView.prototype.bi = function (a, b) {
        _super.prototype.bi.call(this, a, b);
        var c = new DataTemplatePassInfo();
        c.isHitTestRender = b;
        c.context = a.h();
        c.viewportTop = this.b9.top;
        c.viewportLeft = this.b9.left;
        c.viewportWidth = this.b9.width;
        c.viewportHeight = this.b9.height;
        c.passID = "Markers";
        var d = new DataTemplateRenderInfo();
        d.passInfo = c;
        d.isHitTestRender = b;
        var e = new DataTemplateMeasureInfo();
        e.passInfo = c;
        var f = false;
        var g = a.h();
        e.context = g;
        d.context = g;
        var h = 0;
        var i = 0;
        if (this.dv.abg != null && this.dv.abg.passStarting != null) {
            this.dv.abg.passStarting(c);
        }
        for (var j = 0; j < this.d1.count; j++) {
            var k = this.d1._inner[j];
            if (k._visibility == 1) {
                continue;
            }
            this.bu(k, j, b);
            if (b) {
                k = this.dq;
            }
            if (!f) {
                e.width = k.width;
                e.height = k.height;
                e.renderOffsetX = 0;
                e.renderOffsetY = 0;
                e.renderContext = a;
                var l = k.ah;
                if (l.measure != null) {
                    e.data = k.content;
                    l.measure(e);
                    f = e.isConstant;
                    if (f) {
                        h = e.width;
                        i = e.height;
                    }
                }
                d.availableWidth = e.width;
                d.availableHeight = e.height;
                d.renderOffsetX = e.renderOffsetX;
                d.renderOffsetY = e.renderOffsetY;
                d.renderContext = a;
            }
            else {
                d.availableWidth = h;
                d.availableHeight = i;
            }
            if (!isNaN_(k.width) && !isInfinity(k.width)) {
                d.availableWidth = k.width;
            }
            if (!isNaN_(k.height) && !isInfinity(k.height)) {
                d.availableHeight = k.height;
            }
            a.q(d, k);
            k.m = d.availableWidth;
            k.l = d.availableHeight;
            k.ai = d.renderOffsetX;
            k.aj = d.renderOffsetY;
        }
        if (this.dv.abg != null && this.dv.abg.passCompleted != null) {
            this.dv.abg.passCompleted(c);
        }
    };
    ScatterPolygonSeriesView.prototype.d8 = function () {
        this.dv.abg = null;
    };
    ScatterPolygonSeriesView.prototype.d5 = function () {
        this.dv.abg = null;
        this.dv.abg = this.dv.abi;
    };
    ScatterPolygonSeriesView.prototype.d6 = function () {
        this.dv.abx = null;
    };
    ScatterPolygonSeriesView.prototype.d3 = function () {
        this.dv.abx = null;
        if (!isNaN_(this.f.id) && this.f.id != 1) {
            var a = BrushUtil.s(this.dv.abz, this.f.id);
            this.dv.abx = a;
        }
        else {
            this.dv.abx = this.dv.abz;
        }
    };
    ScatterPolygonSeriesView.prototype.d7 = function () {
        this.dv.aby = null;
    };
    ScatterPolygonSeriesView.prototype.d4 = function () {
        this.dv.aby = null;
        this.dv.aby = this.dv.ab0;
    };
    ScatterPolygonSeriesView.prototype.d2 = function (a) {
        switch (a) {
            case "CircleMarkerTemplate":
                this.dv.abg = this.dv.dc.td;
                break;
            case "TriangleMarkerTemplate":
                this.dv.abg = this.dv.dc.tm;
                break;
            case "PyramidMarkerTemplate":
                this.dv.abg = this.dv.dc.tj;
                break;
            case "SquareMarkerTemplate":
                this.dv.abg = this.dv.dc.tk;
                break;
            case "DiamondMarkerTemplate":
                this.dv.abg = this.dv.dc.te;
                break;
            case "PentagonMarkerTemplate":
                this.dv.abg = this.dv.dc.th;
                break;
            case "HexagonMarkerTemplate":
                this.dv.abg = this.dv.dc.tf;
                break;
            case "TetragramMarkerTemplate":
                this.dv.abg = this.dv.dc.th;
                break;
            case "PentagramMarkerTemplate":
                this.dv.abg = this.dv.dc.ti;
                break;
            case "HexagramMarkerTemplate":
                this.dv.abg = this.dv.dc.tg;
                break;
        }
    };
    ScatterPolygonSeriesView.prototype.ea = function () {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(this.d1)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ah = this.dv.abg;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.a2();
    };
    ScatterPolygonSeriesView.prototype.ei = function (a) {
        if (this.eh == null) {
            this.eh = new DataTemplateMeasureInfo();
            this.eh.context = this.m.h();
        }
        this.eh.width = a.width;
        this.eh.height = a.height;
        this.eh.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.eh);
        }
        return new Size(1, this.eh.width, this.eh.height);
    };
    ScatterPolygonSeriesView.prototype.ax = function (a) {
        var e_5, _a;
        var b = a;
        _super.prototype.ax.call(this, b);
        try {
            for (var _b = __values(fromEnum(this.dw.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = this.dw.item(c);
                if (d._visibility != 1) {
                    var e = typeCast(ScatterPolygonSeries.$, this.f);
                    var f = this.f.bc.getMarkerVisualData(e, d, e.abg);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.f.ba.a$u(this.f);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.dv.title + "</span><br/>";
        a += "</div>";
        return a;
    };
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
}(ShapeSeriesViewBase));
export { ScatterPolygonSeriesView };
